//*****************************************************************************
// file:        btfbase.vert
// version:     1.0
// description: BTFBASE GPU vertex shader
// author:      Jiri Filip, UTIA AS CR
// date:        28/01/2010
//*****************************************************************************

attribute vec4 camera;
attribute vec4 light;

attribute vec3 tangent;
attribute vec3 binormal;
attribute vec3 normal;

varying vec3 T; // tangent
varying vec3 B; // binormal
varying vec3 N; // normal

varying vec3 L; // normalized light vector
varying vec3 C; // normalized light vector

void main()
{
  // tangent space computation ================================
  N = normalize(gl_NormalMatrix *normal); //gl_NormalMatrix *
  T = normalize(gl_NormalMatrix *tangent);
  B = cross(N,T);

  // light and camera vectors computation =====================
  //  vec3 vVertex = vec3(gl_ModelViewMatrix * gl_Vertex);
  L = normalize(light.xyz  - gl_Vertex.xyz); 
  C = normalize(camera.xyz - gl_Vertex.xyz);

  // standard transformations =================================
  gl_TexCoord[0] = gl_MultiTexCoord0;		
  gl_Position = ftransform();
}
